<?php
class StyleZero{
	static string$head='';
	static array$css=[],$js=[];
	static bool$development=false;
	static function init(bool$development,bool$autocompile){
		if(static::$development=$development&&$autocompile&&($time=time())>(int)@file_get_contents($file='.stylezero.time')+1){
			@file_put_contents($file,$time);
			if($bin=static::get_bin())
				shell_exec($bin);
			else
				static::$head.="<script>setTimeout(()=>document.body.insertAdjacentHTML('afterend','<div style=\"position:fixed;width:400px;max-width:calc(100vw - 70px);top:20px;right:20px;padding:10px 15px;border-radius:4px;background:indianred;color:white;font-family:sans-serif;font-size:x-small;font-weight:bold\">StyleZero cannot run automatically.<br>Run stylezero via terminal in watch mode:<br>&emsp;stylezero --watch<br>To disable this message set the autocompile argument to false in the index.php file:<br>&emsp;StyleZero::init(development:true,autocompile:false);</div>'),100)</script>";
		}
	}
	static function get_bin():string{
		if(!is_callable('shell_exec'))
			return'';
		if(is_numeric(str_replace('.','',shell_exec('stylezero --version'))))
			return'stylezero';
		$file=DIRECTORY_SEPARATOR==='/'?'~/.local/opt/stylezero/stylezero':'%LocalAppData%\Programs\StyleZero\stylezero';
		if(is_numeric(str_replace('.','',shell_exec($file.' --version'))))
			return$file;
		return'';
	}
	static function css(int|string$id){
		if(!in_array($id,static::$css))
			static::$css[]=$id;
	}
	static function js(int$id){
		if(!in_array($id,static::$js))
			static::$js[]=$id;
	}
	static function head():string{
		static::css('stylezero');
		foreach(static::$css as$id)
			static::$head.='<link rel="stylesheet" href="public/stylezero/'.$id.'.css">';
		foreach(static::$js as$id)
			static::$head.='<script src="public/stylezero/'.$id.'.js"></script>';
		return static::$head;
	}
}
